/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.spagosoa.smx.listeners;

import java.util.Set;

import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.NormalizedMessage;

import org.apache.servicemix.jbi.event.ExchangeEvent;
import org.apache.servicemix.jbi.event.ExchangeListener;
import org.apache.servicemix.jbi.messaging.MessageExchangeImpl;

public class TraceAttachmentListener implements ExchangeListener {

	public static final Object lock = new Object();
	
	public static final String MEP_INONLY = "org.apache.servicemix.jbi.messaging.InOnlyImpl";
	public static final String MEP_INOUT = "org.apache.servicemix.jbi.messaging.InOutImpl";
	public static final String MEP_ROBUSTINONLY = "org.apache.servicemix.jbi.messaging.RobustInOnlyImpl";
	public static final String MEP_INOPTIONALOUT = "org.apache.servicemix.jbi.messaging.InOptionalOutImpl";
	
	public void exchangeSent(ExchangeEvent event) {
        //System.out.println(" ============================ Exchange accepted  ================================== ");
		 MessageExchange exchange = event.getExchange();
	        if (exchange instanceof MessageExchangeImpl == false) {
	            throw new IllegalArgumentException("exchange should be a MessageExchangeImpl");
	        }
	        
	        	
	        	synchronized (lock) {
	        		NormalizedMessage in = exchange.getMessage("in");
	        		NormalizedMessage out = exchange.getMessage("out");
	        		
	        		if (in != null){
	        			Set attachmentsName = in.getAttachmentNames();
	        			if (attachmentsName.size() > 0){
	        				System.out.println(" >>>>>>>>>>>> There are attachments in IN Message " );
	        				
	        			}else{
	        				System.out.println(" >>>>>>>>>>>> NO attachments in IN Message " );
	        			}
	        		}
	        		
	        		if (out != null){
	        			Set attachmentsName = out.getAttachmentNames();
	        			if (attachmentsName.size() > 0){
	        				System.out.println(" >>>>>>>>>>>> There are attachments in OUT Message " );
	        			}else{
	        				System.out.println(" >>>>>>>>>>>> NO attachments in OUT Message " );
	        			}
	        		}		            
					
				}
	        	
	}


	public TraceAttachmentListener() {
		super();
	}


	
	public String getMep(MessageExchange exchange) {
		String mepClassName = exchange.getClass().getName();
		return mepClassName;
	}
	
	public void traceMessage(NormalizedMessage message) {
		
	}


	public void exchangeAccepted(ExchangeEvent arg0) {
//        System.out.println(" ============================ Exchange sent  ================================== ");
	}

	

}
